CustomAdaptor in Syncfusion JavaScript Grid

18 Nov 20189 minutes to read

The CustomAdaptor in the Syncfusion JavaScript Grid allows to create their own custom adaptors by extending the built-in adaptors. The custom adaptor involves handling the query process, requests, and responses of the built-in adaptor. The CustomAdaptor can be used to extend OData V4 services, enabling efficient data fetching and manipulation. By default, there are three built-in methods available for CustomAdaptor.

Types of CustomAdaptor methods

There are three types of methods in custom adaptors.

ProcessQuery

The ProcessQuery method handles the execution of a query sent to a dataSource, such as a database or custom data service. This query is responsible for performing operations like data retrieval, insertion, updating, or deletion. The ProcessQuery method accepts two arguments:

  • DataManager: Used to modify the URL dynamically.

  • Query: Allows setting additional parameter values or modifying queries such as sorting, filtering, and grouping, etc.

DataManager

DataManager

Query

Query

beforeSend

The beforeSend method is executed before a request is sent to the server. This function allows modifying parameters, request headers, and data, or performing validation before the request is processed. It accepts three arguments:

  • DataManager: Provides the dataSource and adaptor value.

  • Request: Used to send custom headers, such as setting the Authorization header.

  • Settings: An optional argument that allows additional configurations.

DataManager

DataManager

Request

Request

Settings

Settings

processResponse

The processResponse method handles the response received from the server after an asynchronous request. It is responsible for parsing the response data, managing errors, and preparing the data for further processing. This method can accept multiple optional arguments, allowing customization based on specific requirements.

This guide provides detailed instructions on binding data and performing CRUD (Create, Read, Update, Delete) actions using the CustomAdaptor by extending the ODataV4Adaptor in your Syncfusion JavaScript Grid.

Creating an Custom service

To configure a server with Syncfusion JavaScript Grid, you need to follow the below steps:

Handling filtering operation

To enable filtering in your web application using the custom adaptor, extend the OData support in your service configuration. This involves adding the Filter method within the OData setup, allowing data to be filtered based on specified criteria. Once configured, clients can use the $filter query option in requests to retrieve specific data entries.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the orders entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() // Use Filter method for filtering.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));

Single column filtering

Filtering query

Multi column filtering

Filtering query

Handling searching operation

To enable search functionality in your web application using the custom adaptor, extend the OData support in your service configuration. This requires adding the Filter method within the OData setup, allowing data to be filtered based on specified criteria. Once configured, clients can use the $filter query option in their requests to search for specific data entries.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the orders entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() // Use Filter method for searching.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));

Searching query

Handling sorting operation

To enable sorting operations in your web application using the custom adaptor, first configure the custom adaptor to extend OData support in your service collection. This involves adding the OrderBy method within the OData setup, allowing data to be sorted based on specified criteria. Once enabled, clients can use the $orderby query option in their requests to sort data entries by desired attributes.

// Create a new instance of the web application builder. 
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the orders entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .OrderBy() // Use this method for sorting.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));

Single column sorting

Single column sorting query

Multi column sorting

Multi column sorting query

Handling paging operation

To implement paging in your web application using the CustomAdaptor with OData, use the SetMaxTop method in your OData setup to define the maximum number of records returned per request. Once configured, clients can utilize the $skip and $top query options to specify the number of records to skip and retrieve, respectively.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the orders entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .SetMaxTop(null)
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));

paging query

Handling CRUD operations

To manage CRUD (Create, Read, Update, and Delete) operations using CustomAdaptor, follow the provided guide for configuring the Syncfusion JavaScript Grid for editing and utilize the sample implementation of the OrdersController in your server application. This controller processes HTTP requests for CRUD operations, including GET, POST, PATCH, and DELETE.

To enable CRUD operations in the Syncfusion JavaScript Grid within an Angular application, follow the below steps:

Normal/Inline editing is the default edit mode for the Syncfusion JavaScript Grid. To enable CRUD operations, ensure that the isPrimaryKey property is set to true for a specific Grid column, ensuring that its value is unique.

Insert Record

To insert a new record into your Syncfusion JavaScript Grid, you can utilize the HttpPost method in your server application. Below is a sample implementation of inserting a record using the OrdersController:

/// <summary>
/// Inserts a new order to the collection.
/// </summary>
/// <param name="addRecord">The order to be inserted.</param>
/// <returns>It returns the newly inserted record detail.</returns>
[HttpPost]
[EnableQuery]
public IActionResult Post([FromBody] OrdersDetails addRecord)
{
    if (order == null)
    {
        return BadRequest("Null order");
    }

    OrdersDetails.GetAllRecords().Insert(0, addRecord);
    return Ok(addRecord);
}

ODataV4Adaptor-Insert-record

Update Record

Updating a record in the Syncfusion JavaScript Grid can be achieved by utilizing the HttpPatch method in your controller. Here’s a sample implementation of updating a record:

/// <summary>
/// Updates an existing order.
/// </summary>
/// <param name="key">The ID of the order to update.</param>
/// <param name="updateRecord">The updated order details.</param>
/// <returns>It returns the updated order details.</returns>
[HttpPatch("{key}")]
public IActionResult Patch(int key, [FromBody] OrdersDetails updatedOrder)
{
    if (updatedOrder == null)
    {
        return BadRequest("No records");
    }
    var existingOrder = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (existingOrder != null)
    {
        // If the order exists, update its properties.
        existingOrder.CustomerID = updatedOrder.CustomerID ?? existingOrder.CustomerID;
        existingOrder.EmployeeID = updatedOrder.EmployeeID ?? existingOrder.EmployeeID;
        existingOrder.ShipCountry = updatedOrder.ShipCountry ?? existingOrder.ShipCountry;
    }
    return Ok(existingOrder);
}

ODataV4Adaptor-Update-record

Delete Record

To delete a record from your Syncfusion JavaScript Grid, you can utilize the HttpDelete method in your controller. Below is a sample implementation:

/// <summary>
/// Deletes an order.
/// </summary>
/// <param name="key">The key of the order to be deleted.</param>
/// <returns>The deleted order.</returns>
[HttpDelete("{key}")]
public IActionResult Delete(int key)
{
    var order = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (order != null)
    {
        OrdersDetails.GetAllRecords().Remove(order);
    }
    return Ok(order);
}

ODataV4Adaptor-Delete-record

Custom Remote Data Binding in Syncfusion React Grid

18 Nov 201824 minutes to read

The CustomAdaptor in the React Data Grid is a powerful extension mechanism that customizes any existing adaptor (UrlAdaptor, WebApiAdaptor, ODataV4Adaptor, GraphQLAdaptor) to meet specific application requirements. Instead of creating an entirely new adaptor from scratch, CustomAdaptor extends and modifies the behavior of existing adaptors by intercepting and customizing HTTP requests and responses.

For detailed guidance, refer to the DataManager CustomAdaptor documentation, which explains the usage of custom adaptors in depth. For complete server-side setup and advanced implementation details, see the DataManager ODataV4Adaptor documentation, covering endpoint configuration, query handling, and recommended practices for integrating OData V4 services.

Once the project creation and backend setup are complete, the next step is to render the React Data Grid component on the client side.

React Grid setup and client-side configuration

After finishing the backend setup for the ODataV4Adaptor ASP.NET Core project, next step is to integrate the React Data Grid on the client side by following these instructions.

Step 1: Installing Syncfusion packages

Right‑click the ODataV4Adaptor.client folder in Solution Explorer and select Open in Terminal (available in newer Visual Studio versions), or open a Developer Command Prompt/PowerShell from the Start menu and navigate manually to the ODataV4Adaptor.client directory. Once inside the folder, confirm that package.json is present, then run the following commands to install the required Syncfusion® packages:

npm install @syncfusion/ej2-react-grids --save
npm install @syncfusion/ej2-data --save

Step 2: Add CSS styles

Navigate to the src folder and open the index.css stylesheet file. Add the required CSS import statements to include the Syncfusion® Grid styles.

@import '../node_modules/@syncfusion/ej2-base/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-react-grids/styles/material3.css';

Import the stylesheet in the main.jsx application entry point:

import { StrictMode } from 'react'
import { createRoot } from 'react-dom/client'
import './index.css'
import App from './App.jsx'

createRoot(document.getElementById('root')).render(
  <StrictMode>
    <App />
  </StrictMode>,
)

Step 3: Create React Grid component with CustomAdaptor

Integrating a CustomAdaptor with the React Data Grid requires configuring the DataManager as the communication bridge between the Grid component and the backend data source. The CustomAdaptor serves as a powerful customization layer that provides complete control over how data operations—such as filtering, sorting, paging, and querying—are processed and transmitted to the server.

Step 3.1: Creating an Extended ODataV4Adaptor:

The first step involves creating a custom adaptor by extending the existing ODataV4Adaptor class. This extension allows modification of the default behavior to meet specific application requirements.

Begin by creating a new TypeScript file named CustomAdaptor.ts in the project’s source directory. This file will house the custom adaptor class definition.

Understanding the SerialNoAdaptor implementation:

The example below demonstrates a SerialNoAdaptor class that extends ODataV4Adaptor to dynamically add serial numbers to each record after receiving the response from the server. This is particularly useful when the server data does not include sequential numbering but the Grid needs to display row numbers.

The implementation requires importing specific modules from Syncfusion packages:

  • setValue from @syncfusion/ej2-base – A utility function for safely setting property values on objects
  • DataManager, ODataV4Adaptor, and Query from @syncfusion/ej2-data – Core data management classes

The Syncfusion® DataManager provides built‑in extensibility points that allow custom logic to be applied both before a request is sent to the server and after a response is received. This is achieved by overriding adaptor methods, ensuring that request customization and response transformation are handled in a consistent and centralized manner. The following table explains the overridden methods in a CustomAdaptor and their execution phases:

Method Execution Phase Purpose & Key Actions
processResponse After receiving server response, before Grid rendering Adds sequential “SNo” (serial number) to each record by iterating through response.result → displays row numbers when the server does not provide them
processQuery Before sending request to server Sets custom OData endpoint URL and adds extra query parameters → enables dynamic URLs and request tracking/identification
beforeSend Immediately before HTTP request is sent Adds Authorization: Bearer header using token from window → automatically authenticates every API request
import { setValue } from '@syncfusion/ej2-base';
import { DataManager, ODataV4Adaptor, Query, } from '@syncfusion/ej2-data';
export class SerialNoAdaptor extends ODataV4Adaptor {
    public processResponse() {
        let i = 0;
        const original: any = super.processResponse.apply(this, arguments as any);
        /* Adding serial number */
        if (original.result) {
            original.result.forEach((item: any) => setValue('SNo', ++i, item));
        }
        return original;
    }

    public processQuery(dm: DataManager, query: Query): Object {
        dm.dataSource.url = 'https://localhost:xxxx/odata/orders';
        query.addParams('Syncfusion in React Grid', 'true');
        const result = super.processQuery.apply(this, arguments as any);
        return result;
    }

    public beforeSend(dm: any, request: any, settings: any) {
        request.headers.set('Authorization', `Bearer ${(window as any).token}`);
        super.beforeSend(dm, request, settings);
    }
}

Step 3.2: Integrating CustomAdaptor into React Grid:

After creating the custom adaptor class, integrate it with the React Grid in the main application file (typically App.tsx or App.jsx). This requires importing the necessary modules and configuring the Grid to use the custom adaptor:

  • Import DataManager from @syncfusion/ej2-data to act as the link between the Grid and the OData service.
  • Import CustomAdaptor from the local ./CustomAdaptor file to apply custom request and response logic.
  • Create DataManager instance by setting the service endpoint URL (e.g., https://localhost:xxxx/odata/Orders) in the url property.
  • Assign CustomAdaptor to the adaptor property so that all operations (filtering, sorting, paging, querying) use the customized pipeline.
  • Bind DataManager to the Grid’s dataSource property, enabling the Grid to automatically apply the custom logic during data communication.
import { DataManager } from '@syncfusion/ej2-data';
import {CustomAdaptor} from './CustomAdaptor';
import { ColumnDirective, ColumnsDirective, GridComponent } from '@syncfusion/ej2-react-grids';

function App() {
    const data = new DataManager({ 
      url:'https://localhost:xxxx/odata/Orders', // Here xxxx represents the port number
      adaptor: new CustomAdaptor()
    });
    return <GridComponent dataSource={data} >
        <ColumnsDirective>
            <ColumnDirective field='SNo' headerText='SNO' width='150'/>
            <ColumnDirective field='OrderID' headerText='Order ID' isPrimaryKey={true} width='150' textAlign='Right'></ColumnDirective>
            <ColumnDirective field='CustomerID' headerText='Customer ID' width='150'></ColumnDirective>
            <ColumnDirective field='EmployeeID' headerText='Employee ID' width='150'/>
            <ColumnDirective field='ShipCountry' headerText='Ship Country' width='150'/>
        </ColumnsDirective>
    </GridComponent>
};
export default App;

Replace https://localhost:xxxx/odata/Orders with the actual API endpoint that returns data in JSON format.

Performing data operations

This section covers implementation of advanced Grid features including filtering, sorting, pagination, and complete CRUD operations.

Filtering

Filtering is enabled by setting the allowFiltering property to true and injecting the Filter module from @syncfusion/ej2-react-grids into the Grid.

import { ColumnDirective, ColumnsDirective, GridComponent, Filter, Inject } from '@syncfusion/ej2-react-grids';

function App() {
    return <GridComponent dataSource={data} allowFiltering={true}>
        <ColumnsDirective>
            <ColumnDirective field='SNo' headerText='SNO' width='150' allowSorting={false} allowFiltering={false} allowSearching={false} isIdentity={true} />
            {/* Include additional columns here */}
        </ColumnsDirective>
        <Inject services={[Filter]} />
    </GridComponent>
};

When working with a custom adaptor, filter operations can be enabled by extending OData support within the service configuration. As part of this setup, the Filter method is included in the OData configuration, allowing the service to interpret filtering criteria. Once configured, clients can use the $filter query option in their requests to retrieve data entries that match specific conditions.

Single column filtering:

Filtering query

Multi-column filtering:

Multiple columns can be filtered simultaneously. Example: Apply filter criteria “ShipCountry = “Denmark” AND OrderID > 10005”.

Filtering query

// Create a new instance of the web application builder
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() //filtering
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
import { DataManager } from '@syncfusion/ej2-data';
import {CustomAdaptor} from './CustomAdaptor';
import { ColumnDirective, ColumnsDirective, GridComponent, Filter } from '@syncfusion/ej2-react-grids';

function App() {
    const data = new DataManager({ 
      url:'https://localhost:xxxx/odata/Orders', // Here xxxx represents the port number.
      adaptor: new CustomAdaptor()
    });
    return <GridComponent dataSource={data} allowFiltering={true}>
        <ColumnsDirective>
            <ColumnDirective field='SNo' headerText='SNO' width='150'/>
            <ColumnDirective field='OrderID' headerText='Order ID' isPrimaryKey={true} width='150' textAlign='Right'></ColumnDirective>
            <ColumnDirective field='CustomerID' headerText='Customer ID' width='150'></ColumnDirective>
            <ColumnDirective field='EmployeeID' headerText='Employee ID' width='150'/>
            <ColumnDirective field='ShipCountry' headerText='Ship Country' width='150'/>
        </ColumnsDirective>
         <Inject services={[Filter]} />
    </GridComponent>
};
export default App;

Searching

The searching feature in the Grid is enabled by adding Search to the Grid’s toolbar items and injecting the Toolbar module.

import { ColumnDirective, ColumnsDirective, GridComponent, Toolbar, Inject } from '@syncfusion/ej2-react-grids';

function App() {
    const toolbar = ['Search'];
    return <GridComponent dataSource={data} allowFiltering={true} toolbar={toolbar}>
        <ColumnsDirective>
            <ColumnDirective field='SNo' headerText='SNO' width='150' allowSorting={false} allowFiltering={false} allowSearching={false} isIdentity={true} />
            {/* Include additional columns here */}
        </ColumnsDirective>
        <Inject services={[Toolbar]} />
    </GridComponent>
};

When working with a custom adaptor, search operations can be enabled by extending OData support within the service configuration. As part of this setup, the Filter method is included in the OData configuration, allowing the service to interpret search criteria. Once configured, clients can use the $filter query option in their requests to retrieve data entries that match search conditions.

Search usage:

The search box in the Grid top‑right corner can be used to enter any keyword, and matching records from all columns will be shown instantly. Clear the search input to return to the full data set.

Searching query

// Create a new instance of the web application builder
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() // searching
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
import { DataManager } from '@syncfusion/ej2-data';
import {CustomAdaptor} from './CustomAdaptor';
import { ColumnDirective, ColumnsDirective, GridComponent, Toolbar, ToolbarItems } from '@syncfusion/ej2-react-grids';

function App() {
    const data = new DataManager({ 
      url:'https://localhost:xxxx/odata/Orders', // Here xxxx represents the port number.
      adaptor: new CustomAdaptor()
    });
    const toolbar: ToolbarItems[] = ['Search'];
    return <GridComponent dataSource={data} toolbar={toolbar}>
        <ColumnsDirective>
            <ColumnDirective field='OrderID' headerText='Order ID' isPrimaryKey={true} width='150' textAlign='Right'></ColumnDirective>
            <ColumnDirective field='CustomerID' headerText='Customer ID' width='150'></ColumnDirective>
            <ColumnDirective field='EmployeeID' headerText='Employee ID' width='150'/>
            <ColumnDirective field='ShipCountry' headerText='Ship Country' width='150'/>
        </ColumnsDirective>
        <Inject services={[Toolbar]} />
    </GridComponent>
};
export default App;

Sorting

The sorting feature in the Grid allows users to organize records in ascending or descending order based on one or more columns. The sorting feature in the Grid is enabled by setting the allowSorting property to true and injecting the Sort module.

import { ColumnDirective, ColumnsDirective, GridComponent, Sort, Inject } from '@syncfusion/ej2-react-grids';

function App() {
    return (
        <GridComponent dataSource={data} allowSorting={true}>
            <ColumnsDirective>
                <ColumnDirective field='SNo' headerText='SNO' width='150' allowSorting={false} allowFiltering={false} allowSearching={false} isIdentity={true} />
                {/* Include additional columns here */}
            </ColumnsDirective>
            <Inject services={[Sort]} />
        </GridComponent>
    );
}

When working with a custom adaptor, sorting functionality is supported by extending OData within the service configuration. As part of this setup, the OrderBy method is included in the OData configuration, enabling the service to interpret sorting criteria. Once configured, clients can use the $orderby query option in their requests to sort data entries based on the required attributes.

Single column sorting:

Click the “Customer ID” column header to sort by “CustomerID” field.

Single column sorting query

Multi-column sorting:

Hold the ctrl key and click “Employee ID” followed by “Customer ID” to establish hierarchical sort (primary sort by “Customer ID”, secondary sort by “Employee ID” within each “Customer ID” group).

Multi column sorting query

// Create a new instance of the web application builder 
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .OrderBy() // sorting
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
import { DataManager } from '@syncfusion/ej2-data';
import {CustomAdaptor} from './CustomAdaptor';
import { ColumnDirective, ColumnsDirective, GridComponent, Sort } from '@syncfusion/ej2-react-grids';

function App() {
    const data = new DataManager({ 
      url:'https://localhost:xxxx/odata/Orders', // Here xxxx represents the port number.
      adaptor: new CustomAdaptor()
    });
    return <GridComponent dataSource={data} allowSorting={true}>
        <ColumnsDirective>
            <ColumnDirective field='SNo' headerText='SNO' width='150'/>
            <ColumnDirective field='OrderID' headerText='Order ID' isPrimaryKey={true} width='150' textAlign='Right'></ColumnDirective>
            <ColumnDirective field='CustomerID' headerText='Customer ID' width='150'></ColumnDirective>
            <ColumnDirective field='EmployeeID' headerText='Employee ID' width='150'/>
            <ColumnDirective field='ShipCountry' headerText='Ship Country' width='150'/>
        </ColumnsDirective>
        <Inject services={[Sort]} />
    </GridComponent>
};
export default App;

Pagination

The paging feature allows efficient loading of large data sets through on‑demand loading. Paging in the Grid is enabled by setting the allowPaging property to true and injecting the Page module. This sends parameters to fetch only the data required for the current viewport.

import { ColumnDirective, ColumnsDirective, GridComponent, Page, Inject } from '@syncfusion/ej2-react-grids';

function App() {
    return (
        <GridComponent dataSource={data} allowPaging={true}>
            <ColumnsDirective>
                <ColumnDirective field='SNo' headerText='SNO' width='150' allowSorting={false} allowFiltering={false} allowSearching={false} isIdentity={true} />
                {/* Include additional columns here */}
            </ColumnsDirective>
            <Inject services={[Page]} />
        </GridComponent>
    );
}

When working with a custom adaptor, paging operations can be enabled by extending OData support within the service configuration. As part of this setup, the SetMaxTop method is included in the OData configuration, defining the maximum number of records that can be returned in a single response. Once configured, clients can use the $skip and $top query options in their requests to control the number of records to omit and the number of records to retrieve, ensuring predictable paging behavior within the application’s data handling process.

The following screenshot illustrates the custom adaptor extending OData V4 with a paging query in operation.

paging query

// Create a new instance of the web application builder
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .SetMaxTop(null)
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
import { DataManager } from '@syncfusion/ej2-data';
import {CustomAdaptor} from './CustomAdaptor';
import { ColumnDirective, ColumnsDirective, GridComponent, Page } from '@syncfusion/ej2-react-grids';

function App() {
    const data = new DataManager({ 
      url: 'https://localhost:xxxx/odata/Orders', // Here xxxx represents the port number.
      adaptor: new CustomAdaptor()
    });
    return <GridComponent dataSource={data} allowPaging={true}>
        <ColumnsDirective>
            <ColumnDirective field='SNo' headerText='SNO' width='150'/>
            <ColumnDirective field='OrderID' headerText='Order ID' isPrimaryKey={true} width='150' textAlign='Right'></ColumnDirective>
            <ColumnDirective field='CustomerID' headerText='Customer ID' width='150'></ColumnDirective>
            <ColumnDirective field='EmployeeID' headerText='Employee ID' width='150'/>
            <ColumnDirective field='ShipCountry' headerText='Ship Country' width='150'/>
        </ColumnsDirective>
        <Inject services={[Page]} />
    </GridComponent>
};
export default App;

The Grid has now been successfully created with full functionality, including paging, sorting, filtering, and CRUD features.

CRUD Operations

CRUD (Create, Read, Update, Delete) operations using a CustomAdaptor are handled by setting up the Grid for editing and employing the sample OrdersController in the server application. This controller manages standard HTTP requests such as GET, POST, PATCH, and DELETE to support complete data modification processes.

To enable CRUD operations in the Syncfusion® Grid component within a React application, the following steps outline the required setup:

import { ColumnDirective, ColumnsDirective, GridComponent, ToolbarItems, EditSettingsModel, Toolbar, Edit, Inject } from '@syncfusion/ej2-react-grids';
import { DataManager } from '@syncfusion/ej2-data';
import {CustomAdaptor} from './CustomAdaptor';

function App() {
    const data = new DataManager({ 
      url: 'https://localhost:xxxx/odata/Orders', // Here xxxx represents the port number.
      adaptor: new CustomAdaptor()
    });
    const editSettings: EditSettingsModel = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' };
    const toolbar: ToolbarItems[] = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    const orderIDRules: object = {required: true};
    const customerIDRules: object = {required: true, minLength: 3};
    return <GridComponent dataSource={data} editSettings={editSettings} toolbar={toolbar} height={320}>
        <ColumnsDirective>
            <ColumnDirective field='SNo' headerText='SNO' width='150'/>
            <ColumnDirective field='OrderID' headerText='Order ID' isPrimaryKey={true} width='150' textAlign='Right' validationRules={orderIDRules}></ColumnDirective>
            <ColumnDirective field='CustomerID' headerText='Customer ID' width='150' validationRules={customerIDRules}></ColumnDirective>
            <ColumnDirective field='EmployeeID' headerText='Employee ID' width='150'/>
            <ColumnDirective field='ShipCountry' headerText='Ship Country' width='150'/>
        </ColumnsDirective>
        <Inject services={[Toolbar, Edit]} />
    </GridComponent>
};
export default App;

Normal/Inline editing is the default edit mode for the Grid component. To enable CRUD operations, ensure that the isPrimaryKey property is set to true for a specific Grid column, ensuring that its value is unique.

Insert Record:

Insertion of a new record in the Syncfusion® Grid is handled through the HttpPost method in the server application.

CustomAdaptor-Insert-record

/// <summary>
/// Inserts a new order to the collection.
/// </summary>
/// <param name="addRecord">The order to be inserted.</param>
/// <returns>It returns the newly inserted record detail.</returns>
[HttpPost]
[EnableQuery]
public IActionResult Post([FromBody] OrdersDetails addRecord)
{
    if (order == null)
    {
        return BadRequest("Null order");
    }

    OrdersDetails.GetAllRecords().Insert(0, addRecord);
    return Ok(addRecord);
}

Update Record:

Updating an existing record in the Syncfusion® Grid is handled through the HttpPatch method within the controller.

CustomAdaptor-Update-record

/// <summary>
/// Updates an existing order.
/// </summary>
/// <param name="key">The ID of the order to update.</param>
/// <param name="updateRecord">The updated order details.</param>
/// <returns>It returns the updated order details.</returns>
[HttpPatch("{key}")]
public IActionResult Patch(int key, [FromBody] OrdersDetails updatedOrder)
{
    if (updatedOrder == null)
    {
        return BadRequest("No records");
    }
    var existingOrder = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (existingOrder != null)
    {
        // If the order exists, update its properties
        existingOrder.CustomerID = updatedOrder.CustomerID ?? existingOrder.CustomerID;
        existingOrder.EmployeeID = updatedOrder.EmployeeID ?? existingOrder.EmployeeID;
        existingOrder.ShipCountry = updatedOrder.ShipCountry ?? existingOrder.ShipCountry;
    }
    return Ok(existingOrder);
}

Delete Record:

Deletion of a record from the Syncfusion® Grid is handled through the HttpDelete method in the controller. The following example demonstrates the delete operation in the OrdersController:

CustomAdaptor-delete-record

/// <summary>
/// Deletes an order.
/// </summary>
/// <param name="key">The key of the order to be deleted.</param>
/// <returns>The deleted order.</returns>
[HttpDelete("{key}")]
public IActionResult Delete(int key)
{
    var order = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (order != null)
    {
        OrdersDetails.GetAllRecords().Remove(order);
    }
    return Ok(order);
}

Application execution and verification

Starting the application: Run the application by pressing F5 in Visual Studio. The browser opens and the Grid loads all orders from the service.

Connection verification: Open the browser Developer Tools (F12) and select the “Network” tab. Refresh the page to confirm a request to https://localhost:xxxx and verify that the response contains JSON data.

Troubleshooting

Issue Cause Solution
Grid shows no data Response format incorrect Ensure processResponse returns {result: [], count: 0}
Authentication fails Token not added to headers Verify beforeSend sets “Authorization” header
Paging does not work Missing count in response Ensure response contains count property
Computed fields missing Not setting values properly Use setValue(fieldName, value, item) in processResponse
CRUD operations fail URLs not configured Set insertUrl, updateUrl, removeUrl in DataManager
API called twice Calling super twice Call super.methodName() only once per method

Method override summary

Method When to override Common use cases
processQuery Need to modify request before it is built • Change API endpoints
• Add query parameters
• Route by environment
beforeSend Need to modify request just before sending • Add auth headers
• Add API keys
• Log requests
processResponse Need to transform incoming response • Transform data format
• Add calculated fields
• Handle errors

Complete sample repository

A complete, working sample implementation is available in the GitHub repository.

See also

CustomAdaptor in Syncfusion Angular Grid

18 Nov 201824 minutes to read

The CustomAdaptor in the Syncfusion Angular Grid enables developers to create custom adaptors by extending built-in adaptors. Custom adaptors provide control over query processing, request handling, and response manipulation of the built-in adaptor functionality. The CustomAdaptor extends OData V4 services, enabling efficient data fetching and manipulation. By default, three built-in methods are available for CustomAdaptor implementation.

Types of CustomAdaptor methods

Custom adaptors support three core methods for data operations.

ProcessQuery

The ProcessQuery method handles query execution sent to a dataSource, such as a database or custom data service. This method performs operations like data retrieval, insertion, updating, or deletion. The ProcessQuery method accepts two parameters:

  • DataManager: Modifies the URL dynamically and manages data source configuration.

  • Query: Sets additional parameter values or modifies queries including sorting, filtering, and grouping operations.

DataManager

DataManager

Query

Query

public override processQuery(dm: DataManager, query: Query): Object {
    dm.dataSource.url = 'https://localhost:xxxx/odata/orders'; //Change the url.
    query.addParams('Syncfusion in Angular Grid', 'true'); // Add the additional parameter.
    return super.processQuery.apply(this, arguments as any);
}

beforeSend

The beforeSend method executes before sending a request to the server. This method allows modification of parameters, request headers, and data, or performs validation before request processing. It accepts three parameters:

  • DataManager: Provides the dataSource and adaptor configuration values.

  • Request: Enables custom headers, such as setting the Authorization header for authentication.

  • Settings: Optional parameter that allows additional request configurations.

DataManager

DataManager

Request

Request

Settings

Settings

public override beforeSend(dm: DataManager, request: Request, settings?: any) {
  request.headers.set('Authorization', `true`);
  super.beforeSend(dm, request, settings);
}

processResponse

The processResponse method handles server responses after asynchronous requests. This method parses response data, manages errors, and prepares data for further processing. The method accepts multiple optional parameters, allowing customization based on specific requirements.

public override processResponse() {
   let i = 0;
    const original: any = super.processResponse.apply(this, arguments as any);
    // Adding serial number.
    if (original.result) {
      original.result.forEach((item: any) => setValue('SNo', ++i, item));
    }
    return original;
}

This guide provides detailed instructions on binding data and performing CRUD (Create, Read, Update, Delete) actions using the CustomAdaptor by extending the ODataV4Adaptor in the Syncfusion Angular Grid.

Creating a Custom service

To configure a server with Syncfusion Angular Grid, follow these steps:

1. Project Creation:

Open Visual Studio and create an Angular and ASP.NET Core project named CustomAdaptor. To create an Angular and ASP.NET Core application, follow the documentation link for detailed steps.

2. Install NuGet Packages

Using the NuGet package manager in Visual Studio (Tools → NuGet Package Manager → Manage NuGet Packages for Solution), install the Microsoft.AspNetCore.OData NuGet package.

3. Model Class Creation:

Create a model class named OrdersDetails.cs in the server-side Models folder to represent the order data.

using System.ComponentModel.DataAnnotations;

namespace ODataV4Adaptor.Server.Models
{
    public class OrdersDetails
    {
        public static List<OrdersDetails> order = new List<OrdersDetails>();
        public OrdersDetails()
        {

        }
        public OrdersDetails(
        int OrderID, string CustomerId, int EmployeeID, string ShipCountry)
        {
            this.OrderID = OrderID;
            this.CustomerID = CustomerId;
            this.EmployeeID = EmployeeID;
            this.ShipCountry = ShipCountry;
        }   

        public static List<OrdersDetails> GetAllRecords()
        {
            if (order.Count() == 0)
            {
                int code = 10000;
                for (int i = 1; i < 10; i++)
                {
                    order.Add(new OrdersDetails(code + 1, "ALFKI", i + 0, "Denmark"));
                    order.Add(new OrdersDetails(code + 2, "ANATR", i + 2, "Brazil"));
                    order.Add(new OrdersDetails(code + 3, "ANTON", i + 1, "Germany"));
                    order.Add(new OrdersDetails(code + 4, "BLONP", i + 3, "Austria"));
                    order.Add(new OrdersDetails(code + 5, "BOLID", i + 4, "Switzerland"));
                    code += 5;
                }
            }
            return order;
        }
        [Key]
        public int? OrderID { get; set; }
        public string? CustomerID { get; set; }
        public int? EmployeeID { get; set; }
        public string? ShipCountry { get; set; }
    }
}

4. Build the Entity Data Model

To construct the Entity Data Model for the OData service, utilize the ODataConventionModelBuilder to define the model structure. Create an instance of the ODataConventionModelBuilder, then register the entity set Orders using the EntitySet<T> method, where OrdersDetails represents the CLR type containing order details.

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

5. Register the OData Services

Once the Entity Data Model is built, register the OData services in the ASP.NET Core application. Here’s the configuration:

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));

6. Add controllers

Add controllers to expose the OData endpoints. Here’s an example:

using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.OData.Query;
using ODataV4Adaptor.Server.Models;

namespace ODataV4Adaptor.Server.Controllers
{
    [Route("[controller]")]
    [ApiController]
    public class OrdersController : ControllerBase
    {
        /// <summary>
        /// Retrieves all orders.
        /// </summary>
        /// <returns>The collection of orders.</returns>
        [HttpGet]
        [EnableQuery]
        public IActionResult Get()
        {
            var data = OrdersDetails.GetAllRecords().AsQueryable();
            return Ok(data);
        }
    }
}

7. Run the Application:

Run the application in Visual Studio. The application will be accessible on a URL like https://localhost:xxxx.

After running the application, verify that the server-side API controller successfully returns the order data at the URL (https://localhost:xxxx/odata/Orders). Here xxxx represents the port number.

Connecting Syncfusion Angular Grid to a Custom service extending the ODataV4 service

To integrate the Syncfusion Grid into the Angular and ASP.NET Core project using Visual Studio, follow these steps:

Step 1: Install Syncfusion Package

Open the terminal in the project’s client folder and install the required Syncfusion packages using npm:

npm install @syncfusion/ej2-angular-grids --save
npm install @syncfusion/ej2-data --save

Step 2: Import Grid Module

In the app.module.ts file, import the GridModule from the @syncfusion/ej2-angular-grids package:

import { GridModule } from '@syncfusion/ej2-angular-grids';

@NgModule({
  imports: [
    // Other imports...
    GridModule,
  ],
})
export class AppModule { }

Step 3: Adding CSS reference

Include the necessary CSS files in the styles.css file to style the Syncfusion Angular Grid:

@import '../node_modules/@syncfusion/ej2-base/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css';
@import '../node_modules/@syncfusion/ej2-angular-grids/styles/material3.css';

Step 4: Adding Custom Adaptor

Create a component file (e.g., CustomAdaptor.ts). Import DataManager and ODataV4Adaptor from @syncfusion/ej2-data. Extend the ODataV4Adaptor class to define the custom adaptor. This adaptor implements three key methods: processQuery, beforeSend, and processResponse.

  • The processQuery method modifies the API endpoint URL and sets additional parameters required for query execution.

  • The beforeSend method adds custom headers, such as the Authorization header, before sending the request.

  • The processResponse method customizes the response by modifying data, such as adding a new field (SNo) to the dataset.

import {DataManager, ODataV4Adaptor, Query} from '@syncfusion/ej2-data';
import { setValue } from '@syncfusion/ej2-base';
export class SerialNoAdaptor extends ODataV4Adaptor {
    public override processQuery(dm: any, query: any): Object {
    dm.dataSource.url = 'https://localhost:xxxx/odata/orders'; //Change the url.
    query.addParams('Syncfusion in Angular Grid', 'true'); // Add the additional parameter.
    return super.processQuery.apply(this, arguments as any);
  }
   public override beforeSend(dm: any, request: any, settings: any): void {
     request.headers.set('Authorization', `true`);
     super.beforeSend(dm, request, settings);
   }
  public override processResponse() {
    let i = 0;
    const original: any = super.processResponse.apply(this, arguments as any);
    // Adding serial number.
    if (original.result) {
      original.result.forEach((item: any) => setValue('SNo', ++i, item));
    }
    return original;
  }
}

Step 5: Adding Syncfusion Component

In the component file (e.g., app.component.ts), import DataManager from @syncfusion/ej2-data and CustomAdaptor from ./customadaptor file. Create a DataManager instance specifying the URL of the API endpoint(https:localhost:xxxx/odata/Orders) using the url property. Set CustomAdaptor as the adaptor to handle data requests.

import { Component } from '@angular/core';
import { DataManager } from '@syncfusion/ej2-data';
import { CustomAdaptor } from './customadaptor';
@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
})
export class AppComponent {
  public data: DataManager;
  ngOnInit(): void {
    this.data = new DataManager({
      url: 'https://localhost:xxxx/odata/Orders',
      adaptor: new CustomAdaptor(),
      crossDomain: true,
    });
  }
}

Replace https://localhost:xxxx/odata/Orders with the actual URL of the API endpoint that provides the data in a consumable format (e.g., JSON).

Run the application in Visual Studio. The application will be accessible on a URL like https://localhost:xxxx.

Ensure the API service is configured to handle CORS (Cross-Origin Resource Sharing) if necessary.

  [program.cs]
  builder.Services.AddCors(options =>
  {
    options.AddDefaultPolicy(builder =>
    {
      builder.AllowAnyOrigin().AllowAnyMethod().AllowAnyHeader();
    });
  });
  var app = builder.Build();
  app.UseCors();

Handling filtering operation

To enable filtering in the web application using the custom adaptor, extend the OData support in the service configuration. This involves adding the Filter method within the OData setup, allowing data to be filtered based on specified criteria. Once configured, clients can use the $filter query option in requests to retrieve specific data entries.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() // Use Filter method for filtering.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<div class="control-section">
    <ejs-grid #grid [dataSource]='data' allowFiltering='true'>
        <e-columns>
            <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey='true'></e-column>
            <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
            <e-column field='EmployeeID' headerText='Employee ID' width='120' textAlign='Right'></e-column>
            <e-column field='ShipCountry' headerText='Ship Country' width='150' ></e-column>
        </e-columns>
    </ejs-grid>
</div>
import { Component } from '@angular/core';
import { DataManager } from '@syncfusion/ej2-data';
import { FilterService } from '@syncfusion/ej2-angular-grids'
import { CustomAdaptor } from './customadaptor';
@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  providers: [FilterService],
})
export class AppComponent {
  public data: DataManager;
  ngOnInit(): void {
    this.data = new DataManager({
      url: 'https://localhost:xxxx/odata/Orders',
      adaptor: new CustomAdaptor(),
      crossDomain: true,
    });
  }
}
import { HttpClientModule } from '@angular/common/http';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { FilterService, GridModule } from '@syncfusion/ej2-angular-grids';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule, HttpClientModule,
    AppRoutingModule,
    GridModule
  ],
  providers: [FilterService],
  bootstrap: [AppComponent]
})
export class AppModule { }

Single column filtering

Filtering query

Multi column filtering

Filtering query

Handling searching operation

To enable search functionality in the web application using the custom adaptor, extend the OData support in the service configuration. This requires adding the Filter method within the OData setup, allowing data to be filtered based on specified criteria. Once configured, clients can use the $filter query option in requests to search for specific data entries.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() // Use Filter method for searching.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<div class="control-section">
    <ejs-grid #grid [dataSource]='data'  [toolbar]='toolbar'>
        <e-columns>
            <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey='true'></e-column>
            <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
            <e-column field='EmployeeID' headerText='Employee ID' width='120' textAlign='Right'></e-column>
            <e-column field='ShipCountry' headerText='Ship Country' width='150' ></e-column>
        </e-columns>
    </ejs-grid>
</div>
import { Component } from '@angular/core';
import { DataManager } from '@syncfusion/ej2-data';
import { ToolbarService } from '@syncfusion/ej2-angular-grids'
import { CustomAdaptor } from './customadaptor';
@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  providers: [ToolbarService],
})
export class AppComponent {
  public data: DataManager;
   public toolbar: string[];
  ngOnInit(): void {
    this.data = new DataManager({
      url: 'https://localhost:xxxx/odata/Orders',
      adaptor: new CustomAdaptor(),
      crossDomain: true,
    });
    this.toolbar = ['Search'];
  }
}
import { HttpClientModule } from '@angular/common/http';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { GridModule, ToolbarService } from '@syncfusion/ej2-angular-grids';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule, HttpClientModule,
    AppRoutingModule,
    GridModule
  ],
  providers: [ToolbarService],
  bootstrap: [AppComponent]
})
export class AppModule { }

Searching query

Handling sorting operation

To enable sorting operations in the web application using the custom adaptor, configure the custom adaptor to extend OData support in the service collection. This involves adding the OrderBy method within the OData setup, allowing data to be sorted based on specified criteria. Once enabled, clients can use the $orderby query option in requests to sort data entries by desired attributes.

// Create a new instance of the web application builder. 
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .OrderBy() // Use this method for sorting.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<div class="control-section">
    <ejs-grid #grid [dataSource]='data' [allowSorting]='true'>
        <e-columns>
            <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey='true'></e-column>
            <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
            <e-column field='EmployeeID' headerText='Employee ID' width='120' textAlign='Right'></e-column>
            <e-column field='ShipCountry' headerText='Ship Country' width='150' ></e-column>
        </e-columns>
    </ejs-grid>
</div>
import { Component } from '@angular/core';
import { DataManager } from '@syncfusion/ej2-data';
import { SortService } from '@syncfusion/ej2-angular-grids'
import { CustomAdaptor } from './customadaptor';
@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  providers: [SortService],
})
export class AppComponent {
  public data: DataManager;
  ngOnInit(): void {
    this.data = new DataManager({
      url: 'https://localhost:xxxx/odata/Orders',
      adaptor: new CustomAdaptor(),
      crossDomain: true,
    });
  }
}
import { HttpClientModule } from '@angular/common/http';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { SortService, GridModule } from '@syncfusion/ej2-angular-grids';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule, HttpClientModule,
    AppRoutingModule,
    GridModule
  ],
  providers: [SortService],
  bootstrap: [AppComponent]
})
export class AppModule { }

Single column sorting

Single column sorting query

Multi column sorting

Multi column sorting query

Handling paging operation

To implement paging in the web application using the CustomAdaptor with OData, use the SetMaxTop method in the OData setup to define the maximum number of records returned per request. Once configured, clients can utilize the $skip and $top query options to specify the number of records to skip and retrieve, respectively.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .SetMaxTop(null)
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<div class="control-section">
    <ejs-grid #grid [dataSource]='data' [allowPaging]='true'>
        <e-columns>
            <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey='true'></e-column>
            <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
            <e-column field='EmployeeID' headerText='Employee ID' width='120' textAlign='Right'></e-column>
            <e-column field='ShipCountry' headerText='Ship Country' width='150' ></e-column>
        </e-columns>
    </ejs-grid>
</div>
import { Component } from '@angular/core';
import { DataManager } from '@syncfusion/ej2-data';
import { PageService } from '@syncfusion/ej2-angular-grids'
import { CustomAdaptor } from './customadaptor';
@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  providers: [PageService],
})
export class AppComponent {
  public data: DataManager;
  ngOnInit(): void {
    this.data = new DataManager({
      url: 'https://localhost:xxxx/odata/Orders',
      adaptor: new CustomAdaptor(),
      crossDomain: true,
    });
  }
}
import { HttpClientModule } from '@angular/common/http';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { GridModule, PageService } from '@syncfusion/ej2-angular-grids';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule, HttpClientModule,
    AppRoutingModule,
    GridModule
  ],
  providers: [PageService],
  bootstrap: [AppComponent]
})
export class AppModule { }

paging query

Handling CRUD operations

To manage CRUD (Create, Read, Update, Delete) operations using CustomAdaptor, follow the provided guide for configuring the Syncfusion Angular Grid for editing and utilize the sample implementation of the OrdersController in the server application. This controller processes HTTP requests for CRUD operations, including GET, POST, PATCH, and DELETE.

To enable CRUD operations in the Syncfusion Grid within an Angular application, follow these steps:

<div class="control-section">
    <ejs-grid #grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar'>
        <e-columns>
            <e-column field='OrderID' headerText='Order ID' width='140' textAlign='Right' isPrimaryKey='true' [validationRules]='orderidrules'></e-column>
            <e-column field='CustomerID' headerText='Customer ID' width='140' [validationRules]='customeridrules'></e-column>
            <e-column field='EmployeeID' headerText='Employee ID' width='120' textAlign='Right'></e-column>
            <e-column field='ShipCountry' headerText='Ship Country' width='150' ></e-column>
        </e-columns>
    </ejs-grid>
</div>
import { Component } from '@angular/core';
import { DataManager } from '@syncfusion/ej2-data';
import { EditService, ToolbarService } from '@syncfusion/ej2-angular-grids'
import { CustomAdaptor } from './customadaptor';
@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  providers: [EditService, ToolbarService],
})
export class AppComponent {
  public data: DataManager;
  public editSettings: Object;
  public toolbar: string[];
  public orderidrules: Object;
  public customeridrules: Object;
  ngOnInit(): void {
    this.data = new DataManager({
      url: 'https://localhost:xxxx/odata/Orders',
      adaptor: new CustomAdaptor(),
      crossDomain: true,
    });
    this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
    this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    this.orderidrules = { required: true};
    this.customeridrules = { required: true, minLength: 3 };
  }
}
import { HttpClientModule } from '@angular/common/http';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { EditService, GridModule, ToolbarService } from '@syncfusion/ej2-angular-grids';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule, HttpClientModule,
    AppRoutingModule,
    GridModule
  ],
  providers: [EditService, ToolbarService],
  bootstrap: [AppComponent]
})
export class AppModule { }

Normal/Inline editing is the default edit mode for the Syncfusion Grid. To enable CRUD operations, ensure that the isPrimaryKey property is set to true for a specific Grid column, ensuring that its value is unique.

Insert Record

To insert a new record into the Syncfusion Grid, utilize the HttpPost method in the server application. Below is a sample implementation of inserting a record using the OrdersController:

/// <summary>
/// Inserts a new order to the collection.
/// </summary>
/// <param name="addRecord">The order to be inserted.</param>
/// <returns>It returns the newly inserted record detail.</returns>
[HttpPost]
[EnableQuery]
public IActionResult Post([FromBody] OrdersDetails addRecord)
{
    if (order == null)
    {
        return BadRequest("Null order");
    }

    OrdersDetails.GetAllRecords().Insert(0, addRecord);
    return Ok(addRecord);
}

ODataV4Adaptor-Insert-record

Update Record

Updating a record in the Syncfusion Grid can be achieved by utilizing the HttpPatch method in the controller. Here’s a sample implementation of updating a record:

/// <summary>
/// Updates an existing order.
/// </summary>
/// <param name="key">The ID of the order to update.</param>
/// <param name="updateRecord">The updated order details.</param>
/// <returns>It returns the updated order details.</returns>
[HttpPatch("{key}")]
public IActionResult Patch(int key, [FromBody] OrdersDetails updatedOrder)
{
    if (updatedOrder == null)
    {
        return BadRequest("No records");
    }
    var existingOrder = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (existingOrder != null)
    {
        // If the order exists, update its properties.
        existingOrder.CustomerID = updatedOrder.CustomerID ?? existingOrder.CustomerID;
        existingOrder.EmployeeID = updatedOrder.EmployeeID ?? existingOrder.EmployeeID;
        existingOrder.ShipCountry = updatedOrder.ShipCountry ?? existingOrder.ShipCountry;
    }
    return Ok(existingOrder);
}

ODataV4Adaptor-Update-record

Delete Record

To delete a record from the Syncfusion Grid, utilize the HttpDelete method in the controller. Below is a sample implementation:

/// <summary>
/// Deletes an order.
/// </summary>
/// <param name="key">The key of the order to be deleted.</param>
/// <returns>The deleted order.</returns>
[HttpDelete("{key}")]
public IActionResult Delete(int key)
{
    var order = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (order != null)
    {
        OrdersDetails.GetAllRecords().Remove(order);
    }
    return Ok(order);
}

ODataV4Adaptor-Delete-record

CustomAdaptor in Syncfusion Vue Grid

18 Nov 201824 minutes to read

The CustomAdaptor in the Syncfusion Vue Data Grid allows to create their own custom adaptors by extending the built-in adaptors. The custom adaptor involves handling the query process, requests, and responses of the built-in adaptor. The CustomAdaptor can be used to extend OData V4 services, enabling efficient data fetching and manipulation. By default, there are three built-in methods available for CustomAdaptor.

Types of CustomAdaptor methods

There are three types of methods in custom adaptors.

ProcessQuery

The ProcessQuery method handles the execution of a query sent to a dataSource, such as a database or custom data service. This query is responsible for performing operations like data retrieval, insertion, updating, or deletion. The ProcessQuery method accepts two arguments:

  • DataManager: Used to modify the URL dynamically.

  • Query: Allows setting additional parameter values or modifying queries such as sorting, filtering, and grouping, etc.

DataManager

DataManager

Query

Query

processQuery(dm, query): Object {
    dm.dataSource.url = 'https://localhost:xxxx/odata/orders'; //Change the url.
    query.addParams('Syncfusion in Vue Grid', 'true'); // Add the additional parameter.
    return super.processQuery.apply(this, arguments);
}

beforeSend

The beforeSend method is executed before a request is sent to the server. This function allows modifying parameters, request headers, and data, or performing validation before the request is processed. It accepts three arguments:

  • DataManager: Provides the dataSource and adaptor value.

  • Request: Used to send custom headers, such as setting the Authorization header.

  • Settings: An optional argument that allows additional configurations.

DataManager

DataManager

Request

Request

Settings

Settings

beforeSend(dm, request, settings) {
    request.headers.set('Authorization', `true`);
    super.beforeSend(dm, request, settings);
}

processResponse

The processResponse method handles the response received from the server after an asynchronous request. It is responsible for parsing the response data, managing errors, and preparing the data for further processing. This method can accept multiple optional arguments, allowing customization based on specific requirements.

 processResponse() {
    let i = 0;
    const original = super.processResponse.apply(this, arguments);
    /* Adding serial number */
    if (original.result) {
		original.result.forEach((item) => setValue('SNo', ++i, item));
    }
    return original;
}

This guide provides detailed instructions on binding data and performing CRUD (Create, Read, Update and Delete) actions using the CustomAdaptor by extending the ODataV4Adaptor in your Grid.

Creating an Custom service

To configure a server with Syncfusion Vue Grid, you need to follow the below steps:

1. Project Creation:

Open Visual Studio and create an Vue and ASP.NET Core project named CustomAdaptor. To create an Vue and ASP.NET Core application, follow the documentation link for detailed steps.

2. Install NuGet Packages

Using the NuGet package manager in Visual Studio (Tools → NuGet Package Manager → Manage NuGet Packages for Solution), install the Microsoft.AspNetCore.OData NuGet package.

3. Model Class Creation:

Create a model class named OrdersDetails.cs in the server-side Models folder to represent the order data.

using System.ComponentModel.DataAnnotations;

namespace ODataV4Adaptor.Server.Models
{
  public class OrdersDetails
  {
    public static List<OrdersDetails> order = new List<OrdersDetails>();
    public OrdersDetails()
    {

    }
    public OrdersDetails(
    int OrderID, string CustomerId, int EmployeeID, string ShipCountry)
    {
      this.OrderID = OrderID;
      this.CustomerID = CustomerId;
      this.EmployeeID = EmployeeID;
      this.ShipCountry = ShipCountry;
    }   

    public static List<OrdersDetails> GetAllRecords()
    {
      if (order.Count() == 0)
      {
        int code = 10000;
        for (int i = 1; i < 10; i++)
        {
          order.Add(new OrdersDetails(code + 1, "ALFKI", i + 0, "Denmark"));
          order.Add(new OrdersDetails(code + 2, "ANATR", i + 2, "Brazil"));
          order.Add(new OrdersDetails(code + 3, "ANTON", i + 1, "Germany"));
          order.Add(new OrdersDetails(code + 4, "BLONP", i + 3, "Austria"));
          order.Add(new OrdersDetails(code + 5, "BOLID", i + 4, "Switzerland"));
          code += 5;
        }
      }
      return order;
    }
    [Key]
    public int? OrderID { get; set; }
    public string? CustomerID { get; set; }
    public int? EmployeeID { get; set; }
    public string? ShipCountry { get; set; }
  }
}

4. Build the Entity Data Model

To construct the Entity Data Model for your OData service, utilize the ODataConventionModelBuilder to define the model’s structure. Start by creating an instance of the ODataConventionModelBuilder, then register the entity set Orders using the EntitySet<T> method, where OrdersDetails represents the CLR type containing order details.

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

5. Register the OData Services

Once the Entity Data Model is built, you need to register the OData services in your ASP.NET Core application. Here’s how:

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));

6. Add controllers

Finally, add controllers to expose the OData endpoints. Here’s an example:

using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.OData.Query;
using ODataV4Adaptor.Server.Models;

namespace ODataV4Adaptor.Server.Controllers
{
    [Route("[controller]")]
    [ApiController]
    public class OrdersController : ControllerBase
    {
        /// <summary>
        /// Retrieves all orders.
        /// </summary>
        /// <returns>The collection of orders.</returns>
        [HttpGet]
        [EnableQuery]
        public IActionResult Get()
        {
            var data = OrdersDetails.GetAllRecords().AsQueryable();
            return Ok(data);
        }
    }
}

7. Run the Application:

Run the application in Visual Studio. It will be accessible on a URL like https://localhost:xxxx.

After running the application, you can verify that the server-side API controller is successfully returning the order data in the URL(https://localhost:xxxx/odata/Orders). Here xxxx denotes the port number.

Connecting Syncfusion Vue Grid to an custom service extending the ODataV4 service

To integrate the Syncfusion Grid into your Vue and ASP.NET Core project using Visual Studio, follow the below steps:

Step 1: Install Syncfusion Package

Open your terminal in the project’s client folder and install the required Syncfusion packages using npm:

npm install @syncfusion/ej2-Vue-grids --save
npm install @syncfusion/ej2-data --save

Step 2: Clean Up App.vue and main.css

Remove unnecessary default codes in App.vue and main.css.

Step 3: Adding CSS reference

Include the necessary CSS files in your App.Vue file to style the Syncfusion Vue component:

@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-calendars/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-vue-grids/styles/material.css';

Step 4: Adding Custom Adaptor

Create a component file (e.g., App.vue). Then, import DataManager and ODataV4Adaptor from @syncfusion/ej2-data. Extend the ODataV4Adaptor class to define custom adaptor. This adaptor implements three key methods: processQuery, beforeSend, and processResponse.

  • The processQuery method modifies the API endpoint URL and sets additional parameters required for executing the query.

  • The beforeSend method adds custom headers, such as the Authorization header, before sending the request.

  • The processResponse method customizes the response by modifying data, such as adding a new field (SNo) to the dataset.

import { DataManager, ODataV4Adaptor, Query } from '@syncfusion/ej2-data';
import { setValue } from '@syncfusion/ej2-base';
export default class CustomAdaptor extends ODataV4Adaptor {
  processQuery(dm, query) {
   dm.dataSource.url = 'https://localhost:xxxx/odata/orders'; //Change the url.
   query.addParams('Syncfusion in Vue Grid', 'true'); // Add the additional parameter.
   return super.processQuery.apply(this, arguments);
  }
  beforeSend(dm, request, settings) {
   request.headers.set('Authorization', `true`);
   super.beforeSend(dm, request, settings);
  }
  processResponse() {
   let i = 0;
   const original = super.processResponse.apply(this, arguments);
   // Adding serial number.
   if (original.result) {
	  original.result.forEach((item) => setValue('SNo', ++i, item));
   }
   return original;
  }
}

Step 5: To add the Grid using Composition API or Options API, follow these steps:

In your component file (e.g., App.vue), import DataManager from @syncfusion/ej2-data and CustomAdaptor from ./customadaptor file. Create a DataManager instance specifying the URL of your API endpoint(https:localhost:xxxx/odata/Orders) using the url property. Then, set CustomAdaptor as the adaptor to handle data requests.

<template>
  <div id="app">
   <ejs-grid :dataSource='data'>
    <e-columns>
     <e-column field="SNo" headerText="SNo" width="120" textAlign='Right'></e-column>
     <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
     <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
     <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
     <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
    </e-columns>
   </ejs-grid>
  </div>
</template>

<script setup>
import { provide } from "vue";
import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns } from "@syncfusion/ej2-vue-grids";
import { DataManager } from "@syncfusion/ej2-data";
import CustomAdaptor from './customadaptor';
const data = new DataManager({
  url: 'https://localhost:xxxx/odata/Orders',
  adaptor: new CustomAdaptor(),
});
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>
<template>
 <ejs-grid :dataSource='data'>
  <e-columns>
   <e-column field="SNo" headerText="SNo" width="120" textAlign='Right'></e-column>
   <e-column field='OrderID' headerText='Order ID' width='120' isPrimaryKey="true" textAlign='Right'></e-column>
   <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
   <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
   <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
  </e-columns>
 </ejs-grid>
</template>

<script>
import { GridComponent, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-vue-grids';
import { DataManager } from '@syncfusion/ej2-data';
import CustomAdaptor from './customadaptor';
export default {
  name: "App",
  components: {
	'ejs-grid': GridComponent,
	'e-columns': ColumnsDirective,
	'e-column': ColumnDirective
  },
  data() {
	return {
	  data: new DataManager({
	   url: 'https://localhost:xxxx/odata/Orders',
	   adaptor: new CustomAdaptor(),
	  }),
	};
  },
};
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>

Replace https://localhost:xxxx/odata/Orders with the actual URL of your API endpoint that provides the data in a consumable format (e.g., JSON).

Run the application in Visual Studio. It will be accessible on a URL like https://localhost:xxxx.

Ensure your API service is configured to handle CORS (Cross-Origin Resource Sharing) if necessary.

  [program.cs]
  builder.Services.AddCors(options =>
  {
    options.AddDefaultPolicy(builder =>
    {
      builder.AllowAnyOrigin().AllowAnyMethod().AllowAnyHeader();
    });
  });
  var app = builder.Build();
  app.UseCors();

Handling filtering operation

To enable filtering in your web application using the custom adaptor, extend the OData support in your service configuration. This involves adding the Filter method within the OData setup, allowing data to be filtered based on specified criteria. Once configured, clients can use the $filter query option in requests to retrieve specific data entries.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() // Use Filter method for filtering.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<template>
 <div id="app">
  <ejs-grid :dataSource='data' :allowFiltering='true'>
   <e-columns>
    <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
    <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
    <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
    <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
   </e-columns>
  </ejs-grid>
 </div>
</template>

<script setup>
 import { provide } from "vue";
 import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, Filter  } from "@syncfusion/ej2-vue-grids";
 import { DataManager } from "@syncfusion/ej2-data";
 import CustomAdaptor from './customadaptor';
 const data = new DataManager({
  url: 'https://localhost:xxxx/odata/Orders',
  adaptor: new CustomAdaptor(),
 });
 provide('grid', [Filter]);
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>
<template>
 <ejs-grid :dataSource='data' :allowFiltering='true'>
  <e-columns>
   <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
   <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
   <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
   <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
  </e-columns>
 </ejs-grid>
</template>

<script>
import { GridComponent, ColumnsDirective, ColumnDirective, Filter } from '@syncfusion/ej2-vue-grids';
import { DataManager } from '@syncfusion/ej2-data';
import CustomAdaptor from './customadaptor';
export default {
 name: "App",
 components: {
  'ejs-grid': GridComponent,
  'e-columns': ColumnsDirective,
  'e-column': ColumnDirective
 },
 data() {
  return {
   data: new DataManager({
   url: 'https://localhost:xxxx/odata/Orders',
   adaptor: new CustomAdaptor(),
   }),
  };
},
provide: {
 grid: [Filter]
}
};
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>

Single column filtering

Filtering query

Multi column filtering

Filtering query

Handling searching operation

To enable search functionality in your web application using the custom adaptor, extend the OData support in your service configuration. This requires adding the Filter method within the OData setup, allowing data to be filtered based on specified criteria. Once configured, clients can use the $filter query option in their requests to search for specific data entries.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the orders entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .Filter() // Use Filter method for searching.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<template>
 <div id="app">
  <ejs-grid :dataSource='data' :toolbar='toolbarOptions'>
   <e-columns>
    <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
    <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
    <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
    <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
   </e-columns>
  </ejs-grid>
 </div>
</template>

<script setup>
 import { provide } from "vue";
 import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, Toolbar,  Search } from "@syncfusion/ej2-vue-grids";
 import { DataManager } from "@syncfusion/ej2-data";
 import CustomAdaptor from './customadaptor';
 const data = new DataManager({
  url: 'https://localhost:xxxx/odata/Orders',
  adaptor: new CustomAdaptor(),
 });
 const toolbarOptions = ['Search'];
 provide('grid', [Toolbar, Search ]);
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>
<template>
 <ejs-grid :dataSource='data' :toolbar='toolbarOptions'>
  <e-columns>
   <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
   <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
   <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
   <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
  </e-columns>
 </ejs-grid>
</template>

<script>
 import { GridComponent, ColumnsDirective, ColumnDirective, Toolbar, Search  } from '@syncfusion/ej2-vue-grids';
 import { DataManager } from '@syncfusion/ej2-data';
 import CustomAdaptor from './customadaptor';
 export default {
  name: "App",
  components: {
   'ejs-grid': GridComponent,
   'e-columns': ColumnsDirective,
   'e-column': ColumnDirective
  },
  data() {
   return {
    data: new DataManager({
     url: 'https://localhost:xxxx/odata/Orders',
     adaptor: new CustomAdaptor(),
    }),
    toolbarOptions: ['Search']
   };
  },
  provide: {
   grid: [Toolbar, Search ]
  }
 };
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>

Searching query

Handling sorting operation

To enable sorting operations in your web application using the custom adaptor, first configure the custom adaptor to extend OData support in your service collection. This involves adding the OrderBy method within the OData setup, allowing data to be sorted based on specified criteria. Once enabled, clients can use the $orderby query option in their requests to sort data entries by desired attributes.

// Create a new instance of the web application builder. 
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .OrderBy() // Use this method for sorting.
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<template>
 <div id="app">
  <ejs-grid :dataSource='data' :allowSorting='true'>
   <e-columns>
    <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
    <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
    <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
    <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
   </e-columns>
  </ejs-grid>
 </div>
</template>

<script setup>
 import { provide } from "vue";
 import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, Sort} from "@syncfusion/ej2-vue-grids";
 import { DataManager } from "@syncfusion/ej2-data";
 import CustomAdaptor from './customadaptor';
 const data = new DataManager({
  url: 'https://localhost:xxxx/odata/Orders',
  adaptor: new CustomAdaptor(),
 });
 provide('grid', [Sort]);
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>
<template>
 <ejs-grid :dataSource='data' :allowSorting='true'>
  <e-columns>
   <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
   <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
   <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
   <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
  </e-columns>
 </ejs-grid>
</template>

<script>
 import { GridComponent, ColumnsDirective, ColumnDirective, Sort } from '@syncfusion/ej2-vue-grids';
 import { DataManager } from '@syncfusion/ej2-data';
 import CustomAdaptor from './customadaptor';
 export default {
  name: "App",
  components: {
   'ejs-grid': GridComponent,
   'e-columns': ColumnsDirective,
   'e-column': ColumnDirective
  },
  data() {
   return {
    data: new DataManager({
     url: 'https://localhost:xxxx/odata/Orders',
     adaptor: new CustomAdaptor(),
    })
   };
  },
  provide: {
   grid: [Sort]
  }
 };
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>

Single column sorting

Single column sorting query

Multi column sorting

Multi column sorting query

Handling paging operation

To implement paging in your web application using the CustomAdaptor with OData, use the SetMaxTop method in your OData setup to define the maximum number of records returned per request. Once configured, clients can utilize the $skip and $top query options to specify the number of records to skip and retrieve, respectively.

// Create a new instance of the web application builder.
var builder = WebApplication.CreateBuilder(args);

// Create an ODataConventionModelBuilder to build the OData model.
var modelBuilder = new ODataConventionModelBuilder();

// Register the "Orders" entity set with the OData model builder.
modelBuilder.EntitySet<OrdersDetails>("Orders");

// Add services to the container.

// Add controllers with OData support to the service collection.
builder.Services.AddControllers().AddOData(
    options => options
        .Count()
        .SetMaxTop(null)
        .AddRouteComponents("odata", modelBuilder.GetEdmModel()));
<template>
 <div id="app">
  <ejs-grid :dataSource='data' :allowPaging="true">
   <e-columns>
    <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
    <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
    <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
    <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
   </e-columns>
  </ejs-grid>
 </div>
</template>

<script setup>
 import { provide } from "vue";
 import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, Page} from "@syncfusion/ej2-vue-grids";
 import { DataManager } from "@syncfusion/ej2-data";
 import CustomAdaptor from './customadaptor';
 const data = new DataManager({
  url: 'https://localhost:xxxx/odata/Orders',
  adaptor: new CustomAdaptor(),
 });
 provide('grid', [Page]);
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>
<template>
 <ejs-grid :dataSource='data' :allowPaging="true">
  <e-columns>
   <e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey="true"></e-column>
   <e-column field='CustomerID' headerText='Customer ID' width='160'></e-column>
   <e-column field='EmployeeID' headerText='Employee ID' width='150'  textAlign='Right'></e-column>
   <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
  </e-columns>
 </ejs-grid>
</template>

<script>
 import { GridComponent, ColumnsDirective, ColumnDirective, Page } from '@syncfusion/ej2-vue-grids';
 import { DataManager } from '@syncfusion/ej2-data';
 import CustomAdaptor from './customadaptor';
 export default {
  name: "App",
  components: {
   'ejs-grid': GridComponent,
   'e-columns': ColumnsDirective,
   'e-column': ColumnDirective
  },
  data() {
   return {
    data: new DataManager({
     url: 'https://localhost:xxxx/odata/Orders',
     adaptor: new CustomAdaptor(),
    })
   };
  },
  provide: {
   grid: [Page]
  }
 };
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>

paging query

Handling CRUD operations

To manage CRUD (Create, Read, Update and Delete) operations using CustomAdaptor, follow the provided guide for configuring the Syncfusion Vue Grid for editing and utilize the sample implementation of the OrdersController in your server application. This controller processes HTTP requests for CRUD operations, including GET, POST, PATCH, and DELETE.

To enable CRUD operations in the Grid within an Vue application, follow the below steps:

<template>
 <div id="app">
  <ejs-grid :dataSource='data' :editSettings='editSettings' height='270' :toolbar='toolbar'>
   <e-columns>
    <e-column field='OrderID' headerText='Order ID' textAlign='Right' :isPrimaryKey='true' :validationRules='orderIDRules' width=100></e-column>
    <e-column field='CustomerID' headerText='Customer ID' :validationRules='customerIDRules' width=120></e-column>
    <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
    <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
   </e-columns>
  </ejs-grid>
 </div>
</template>

<script setup>
 import { provide } from "vue";
 import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
 import { DataManager } from "@syncfusion/ej2-data";
 import CustomAdaptor from './customadaptor';
 const data = new DataManager({
  url: 'https://localhost:xxxx/odata/Orders',
  adaptor: new CustomAdaptor(),
 });
 const orderIDRules= { required: true, number: true };
 const customerIDRules= { required: true };
 const editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
 const toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
 provide('grid', [Toolbar, Edit ]);
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>
<template>
 <ejs-grid :dataSource='data' :editSettings='editSettings' height='270' :toolbar='toolbar'>
  <e-columns>
   <e-column field='OrderID' headerText='Order ID' textAlign='Right' :isPrimaryKey='true' :validationRules='orderIDRules' width=100></e-column>
   <e-column field='CustomerID' headerText='Customer ID' :validationRules='customerIDRules' width=120></e-column>
   <e-column field='EmployeeID' headerText='Employee ID' width='150' textAlign='Right'></e-column>
   <e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
  </e-columns>
 </ejs-grid>
</template>

<script>
 import { GridComponent, ColumnsDirective, ColumnDirective, Toolbar, Edit  } from '@syncfusion/ej2-vue-grids';
 import { DataManager } from '@syncfusion/ej2-data';
 import CustomAdaptor from './customadaptor';
 export default {
  name: "App",
  components: {
   'ejs-grid': GridComponent,
   'e-columns': ColumnsDirective,
   'e-column': ColumnDirective
  },
  data() {
   return {
    data: new DataManager({
     url: 'https://localhost:xxxx/odata/Orders',
     adaptor: new CustomAdaptor(),
    }),
    orderIDRules: { required: true, number: true },
    customerIDRules: { required: true },
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel']
   };
  },
  provide: {
   grid: [Toolbar, Edit ]
  }
 };
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-calendars/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-dropdowns/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-navigations/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-popups/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material3.css";
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material3.css";
</style>

Normal/Inline editing is the default edit mode for the Grid. To enable CRUD operations, ensure that the isPrimaryKey property is set to true for a specific Grid column, ensuring that its value is unique.

Insert Record

To insert a new record into your Syncfusion Vue Grid, you can utilize the HttpPost method in your server application. Below is a sample implementation of inserting a record using the OrdersController:

/// <summary>
/// Inserts a new order to the collection.
/// </summary>
/// <param name="addRecord">The order to be inserted.</param>
/// <returns>It returns the newly inserted record detail.</returns>
[HttpPost]
[EnableQuery]
public IActionResult Post([FromBody] OrdersDetails addRecord)
{
    if (order == null)
    {
        return BadRequest("Null order");
    }

    OrdersDetails.GetAllRecords().Insert(0, addRecord);
    return Ok(addRecord);
}

ODataV4Adaptor-Insert-record

Update Record

Updating a record in the Syncfusion Vue Grid can be achieved by utilizing the HttpPatch method in your controller. Here’s a sample implementation of updating a record:

/// <summary>
/// Updates an existing order.
/// </summary>
/// <param name="key">The ID of the order to update.</param>
/// <param name="updateRecord">The updated order details.</param>
/// <returns>It returns the updated order details.</returns>
[HttpPatch("{key}")]
public IActionResult Patch(int key, [FromBody] OrdersDetails updatedOrder)
{
    if (updatedOrder == null)
    {
        return BadRequest("No records");
    }
    var existingOrder = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (existingOrder != null)
    {
        // If the order exists, update its properties
        existingOrder.CustomerID = updatedOrder.CustomerID ?? existingOrder.CustomerID;
        existingOrder.EmployeeID = updatedOrder.EmployeeID ?? existingOrder.EmployeeID;
        existingOrder.ShipCountry = updatedOrder.ShipCountry ?? existingOrder.ShipCountry;
    }
    return Ok(existingOrder);
}

ODataV4Adaptor-Update-record

Delete Record

To delete a record from your Syncfusion Vue Grid, you can utilize the HttpDelete method in your controller. Below is a sample implementation:

/// <summary>
/// Deletes an order.
/// </summary>
/// <param name="key">The key of the order to be deleted.</param>
/// <returns>The deleted order.</returns>
[HttpDelete("{key}")]
public IActionResult Delete(int key)
{
    var order = OrdersDetails.GetAllRecords().FirstOrDefault(o => o.OrderID == key);
    if (order != null)
    {
        OrdersDetails.GetAllRecords().Remove(order);
    }
    return Ok(order);
}

ODataV4Adaptor-Delete-record